#!/usr/bin/env python
""" """

###############################################################################
# Copyright 2016 Hendrix Demers
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
###############################################################################

# Standard library modules.

# Third party modules.

# Local modules.

# Globals and constants variables.

#
# * Characteristic energy of the Ka line.
# *
# * Energy in eV.
#
g_energyKa_eV = [ 0.0000E3, 0.0000E3, 0.0520E3, 0.1090E3, 0.1830E3,
                                                        0.2770E3, 0.3920E3, 0.5250E3, 0.6770E3, 0.8490E3,
                                                        1.0410E3, 1.2540E3, 1.4870E3, 1.7400E3, 2.0140E3,
                                                        2.3080E3, 2.6220E3, 2.9580E3, 3.3140E3, 3.6920E3,
                                                        4.0910E3, 4.5110E3, 4.9520E3, 5.4150E3, 5.8990E3,
                                                        6.4040E3, 6.9300E3, 7.4780E3, 8.0480E3, 8.6390E3,
                                                        9.2520E3, 9.8860E3, 10.544E3, 11.181E3, 11.924E3,
                                                        12.649E3, 13.395E3, 14.165E3, 14.958E3, 15.775E3,
                                                        16.615E3, 17.479E3, 18.367E3, 19.279E3, 20.210E3,
                                                        21.180E3, 22.160E3, 23.170E3, 24.210E3, 25.270E3,
                                                        26.360E3, 27.470E3, 28.610E3, 29.780E3, 30.970E3,
                                                        32.190E3, 33.440E3, 34.720E3, 36.030E3, 37.360E3,
                                                        38.720E3, 40.120E3, 41.540E3, 42.996E3, 44.480E3,
                                                        45.998E3, 47.550E3, 49.130E3, 50.740E3, 52.390E3,
                                                        54.070E3, 54.610E3, 57.530E3, 59.320E3, 61.140E3,
                                                        63.000E3, 64.900E3, 66.830E3, 66.990E3, 70.820E3,
                                                        72.870E3, 74.907E3, 77.110E3, 79.290E3, 81.520E3,
                                                        83.780E3, 86.100E3, 88.470E3, 90.880E3, 93.350E3,
                                                        95.870E3, 98.440E3, 99.693E3, 102.295E3, 104.952E3,
                                                        107.670E3, 110.450E3, 113.298E3, 116.217E3, 119.210E3]
#/**
# * Characteristic energy of the Ka1 line.
# *
# * Energy in eV.
# */
g_energyKa1_eV = [0.0000E3, 0.0000E3, 0.0520E3, 0.1100E3, 0.1850E3,
                                                        0.2820E3, 0.3920E3, 0.5230E3, 0.6770E3, 0.8510E3,
                                                        1.0410E3, 1.2540E3, 1.4870E3, 1.7400E3, 2.0150E3,
                                                        2.3080E3, 2.6220E3, 2.9570E3, 3.3130E3, 3.6910E3,
                                                        4.0900E3, 4.5100E3, 4.9520E3, 5.4140E3, 5.8980E3,
                                                        6.4030E3, 6.9300E3, 7.4770E3, 8.0470E3, 8.6380E3,
                                                        9.2510E3, 9.8850E3, 10.543E3, 11.221E3, 11.923E3,
                                                        12.648E3, 13.394E3, 14.164E3, 14.957E3, 15.774E3,
                                                        16.614E3, 17.478E3, 18.410E3, 19.278E3, 20.214E3,
                                                        21.175E3, 22.162E3, 23.172E3, 24.207E3, 25.270E3,
                                                        26.357E3, 27.471E3, 28.610E3, 29.802E3, 30.970E3,
                                                        32.191E3, 33.440E3, 34.717E3, 36.023E3, 37.359E3,
                                                        38.649E3, 40.124E3, 41.529E3, 42.983E3, 44.470E3,
                                                        45.985E3, 47.528E3, 49.099E3, 50.730E3, 52.360E3,
                                                        54.063E3, 55.757E3, 57.524E3, 59.310E3, 61.131E3,
                                                        62.991E3, 64.886E3, 66.820E3, 68.794E3, 70.821E3,
                                                        72.860E3, 74.957E3, 77.097E3, 79.296E3, 81.525E3,
                                                        83.800E3, 86.119E3, 88.485E3, 90.894E3, 93.334E3,
                                                        95.851E3, 98.428E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3]
#//------------------------------------------------------------------------------
#/**
# * Characteristic energy of the Ka2 line.
# *
# * Energy in eV.
# */
g_energyKa2_eV = [0.0000E3, 0.0000E3, 0.0520E3, 0.1100E3, 0.1850E3,
                                                        0.2820E3, 0.3920E3, 0.5230E3, 0.6770E3, 0.8510E3,
                                                        1.0410E3, 1.2540E3, 1.4860E3, 1.7390E3, 2.0140E3,
                                                        2.3060E3, 2.6210E3, 2.9550E3, 3.3100E3, 3.6880E3,
                                                        4.0850E3, 4.5040E3, 4.9440E3, 5.4050E3, 5.8770E3,
                                                        6.3900E3, 6.9150E3, 7.4600E3, 8.0270E3, 8.6150E3,
                                                        9.2340E3, 9.8540E3, 10.507E3, 11.181E3, 11.877E3,
                                                        12.597E3, 13.335E3, 14.097E3, 14.882E3, 15.690E3,
                                                        16.520E3, 17.373E3, 18.328E3, 19.142E3, 20.072E3,
                                                        21.018E3, 21.988E3, 22.982E3, 24.000E3, 25.042E3,
                                                        26.109E3, 27.200E3, 28.315E3, 29.485E3, 30.623E3,
                                                        31.815E3, 33.033E3, 34.276E3, 35.548E3, 36.845E3,
                                                        38.160E3, 39.523E3, 40.877E3, 42.280E3, 43.737E3,
                                                        45.193E3, 46.686E3, 48.205E3, 49.762E3, 51.326E3,
                                                        52.959E3, 54.579E3, 56.270E3, 57.973E3, 59.707E3,
                                                        61.477E3, 63.278E3, 65.111E3, 66.980E3, 68.894E3,
                                                        70.820E3, 72.794E3, 74.805E3, 76.868E3, 78.956E3,
                                                        81.080E3, 83.243E3, 85.446E3, 87.861E3, 89.942E3,
                                                        92.271E3, 94.649E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3]
#//------------------------------------------------------------------------------
#/**
# * Characteristic energy of the Kb1 line.
# *
# * Energy in eV.
# */
g_energyKb1_eV = [0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3,
                                                        0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3,
                                                        1.06700E3, 1.29700E3, 1.55300E3, 1.83200E3, 2.13600E3,
                                                        2.46400E3, 2.81500E3, 3.19200E3, 3.58900E3, 4.01200E3,
                                                        4.46000E3, 4.93100E3, 5.42700E3, 5.94600E3, 6.49000E3,
                                                        7.05700E3, 7.64900E3, 8.26400E3, 8.90400E3, 9.57100E3,
                                                        10.2630E3, 10.9810E3, 11.7250E3, 12.4950E3, 13.2900E3,
                                                        14.1120E3, 14.9600E3, 15.8340E3, 16.7360E3, 17.6660E3,
                                                        18.6210E3, 19.6070E3, 20.5850E3, 21.6550E3, 22.7210E3,
                                                        23.8160E3, 24.9420E3, 26.0930E3, 27.2740E3, 28.4830E3,
                                                        29.7230E3, 30.9930E3, 32.2920E3, 33.6440E3, 34.9840E3,
                                                        36.3760E3, 37.7990E3, 39.2550E3, 40.7460E3, 42.2690E3,
                                                        43.9450E3, 45.4000E3, 47.2070E3, 48.7180E3, 50.3910E3,
                                                        52.1780E3, 53.9340E3, 55.6900E3, 57.5760E3, 59.3520E3,
                                                        61.2820E3, 63.2090E3, 65.2100E3, 67.2330E3, 69.2980E3,
                                                        71.4040E3, 73.5490E3, 75.7360E3, 77.9680E3, 80.2580E3,
                                                        82.5580E3, 84.9220E3, 87.3350E3, 89.8090E3, 92.3190E3,
                                                        94.8770E3, 97.4830E3, 100.136E3, 102.846E3, 105.592E3,
                                                        108.408E3, 111.289E3, 0.00000E3, 0.00000E3, 0.00000E3,
                                                        0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3]
#//------------------------------------------------------------------------------
#/**
# * Characteristic energy of the Kb2 line.
# *
# * Energy in eV.
# */
g_energyKb2_eV = [0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3,
                                                        0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3,
                                                        0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3,
                                                        0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3,
                                                        0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3,
                                                        0.00000E3, 0.00000E3, 8.32800E3, 8.97600E3, 9.65700E3,
                                                        10.3650E3, 11.1000E3, 11.8630E3, 12.6510E3, 13.4650E3,
                                                        14.3130E3, 15.1840E3, 16.0830E3, 17.0110E3, 17.9690E3,
                                                        18.9510E3, 19.9640E3, 21.0120E3, 22.0720E3, 23.1690E3,
                                                        24.2970E3, 25.4540E3, 26.6410E3, 27.8590E3, 29.1060E3,
                                                        30.3870E3, 31.6980E3, 33.0160E3, 34.4460E3, 35.8190E3,
                                                        37.2550E3, 38.7280E3, 40.2310E3, 41.7720E3, 43.2980E3,
                                                        44.9550E3, 46.5530E3, 48.2410E3, 49.9610E3, 51.7370E3,
                                                        53.4910E3, 55.2920E3, 57.0880E3, 58.9690E3, 60.9590E3,
                                                        62.9460E3, 64.9360E3, 66.9990E3, 69.0900E3, 71.2200E3,
                                                        73.3930E3, 75.6050E3, 77.8660E3, 80.1650E3, 82.5260E3,
                                                        84.9040E3, 87.3430E3, 89.8330E3, 92.3860E3, 94.9760E3,
                                                        97.6160E3, 100.305E3, 103.048E3, 105.838E3, 108.671E3,
                                                        111.575E3, 114.549E3, 0.00000E3, 0.00000E3, 0.00000E3,
                                                        0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3, 0.00000E3]
#//------------------------------------------------------------------------------
#/**
# * Characteristic energy of the La line.
# *
# * Energy in eV.
# */
g_energyLa_eV = [ 0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.341E3,
                                                        0.395E3, 0.452E3, 0.511E3, 0.573E3, 0.637E3,
                                                        0.705E3, 0.776E3, 0.852E3, 0.930E3, 1.012E3,
                                                        1.098E3, 1.188E3, 1.282E3, 1.379E3, 1.480E3,
                                                        1.586E3, 1.694E3, 1.807E3, 1.923E3, 2.042E3,
                                                        2.166E3, 2.293E3, 2.424E3, 2.559E3, 2.697E3,
                                                        2.839E3, 2.984E3, 3.134E3, 3.287E3, 3.414E3,
                                                        3.605E3, 3.769E3, 3.938E3, 4.110E3, 4.287E3,
                                                        4.466E3, 4.651E3, 4.840E3, 5.034E3, 5.230E3,
                                                        5.433E3, 5.636E3, 5.846E3, 6.057E3, 6.273E3,
                                                        6.495E3, 6.720E3, 6.949E3, 7.180E3, 7.416E3,
                                                        7.656E3, 7.899E3, 8.146E3, 8.398E3, 8.653E3,
                                                        8.912E3, 9.175E3, 9.442E3, 9.713E3, 9.989E3,
                                                        10.27E3, 10.55E3, 10.84E3, 11.13E3, 11.43E3,
                                                        11.73E3, 12.03E3, 12.34E3, 12.65E3, 12.97E3,
                                                        13.29E3, 13.61E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3]
#//------------------------------------------------------------------------------
#/**
# * Characteristic energy of the Lb1 line.
# *
# * Energy in eV.
# */
g_energyLb1_eV = [0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.3440E3,
                                                        0.3990E3, 0.4580E3, 0.5190E3, 0.5810E3, 0.6470E3,
                                                        0.7170E3, 0.7900E3, 0.8660E3, 0.9480E3, 1.0320E3,
                                                        1.1220E3, 1.2160E3, 1.3170E3, 1.4190E3, 1.5260E3,
                                                        1.6380E3, 1.7520E3, 1.8720E3, 1.9960E3, 2.1240E3,
                                                        2.2570E3, 2.3950E3, 2.5380E3, 2.6830E3, 2.8340E3,
                                                        2.9900E3, 3.1510E3, 3.3160E3, 3.4870E3, 3.6620E3,
                                                        3.8430E3, 4.0290E3, 4.2200E3, 4.4220E3, 4.6200E3,
                                                        4.8280E3, 5.0430E3, 5.2620E3, 5.4890E3, 5.7220E3,
                                                        5.9560E3, 6.2060E3, 6.4560E3, 6.7140E3, 6.9790E3,
                                                        7.2490E3, 7.5280E3, 7.8100E3, 8.1030E3, 8.4010E3,
                                                        8.7080E3, 9.0210E3, 9.3410E3, 9.6700E3, 10.008E3,
                                                        10.354E3, 10.706E3, 11.069E3, 11.439E3, 11.823E3,
                                                        12.210E3, 12.611E3, 13.021E3, 13.441E3, 13.873E3,
                                                        14.316E3, 14.770E3, 15.233E3, 15.712E3, 16.200E3,
                                                        16.700E3, 17.218E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3]
#//------------------------------------------------------------------------------
#/**
# * Characteristic energy of the Lb2 line.
# *
# * Energy in eV.
# */
g_energyLb2_eV = [0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 2.2190E3,
                                                        2.3670E3, 2.5180E3, 2.6740E3, 2.8360E3, 3.0010E3,
                                                        3.1720E3, 3.3480E3, 3.5280E3, 3.7130E3, 3.9040E3,
                                                        4.1000E3, 4.3010E3, 4.5070E3, 4.7200E3, 4.9360E3,
                                                        5.1560E3, 5.3840E3, 5.6130E3, 5.8500E3, 6.0900E3,
                                                        6.3360E3, 6.5870E3, 6.8420E3, 7.1020E3, 7.3680E3,
                                                        7.6380E3, 7.9120E3, 8.1880E3, 8.4720E3, 8.7580E3,
                                                        9.0480E3, 9.3460E3, 9.6490E3, 9.9590E3, 10.273E3,
                                                        10.596E3, 10.918E3, 11.249E3, 11.582E3, 11.923E3,
                                                        12.268E3, 12.620E3, 12.977E3, 13.338E3, 13.705E3,
                                                        14.077E3, 14.459E3, 14.839E3, 15.227E3, 15.620E3,
                                                        16.022E3, 16.425E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3]
#//------------------------------------------------------------------------------
#/**
# * Characteristic energy of the Lg line.
# *
# * Energy in eV.
# */
g_energyLg_eV = [ 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 2.3020E3,
                                                        2.4620E3, 2.6230E3, 2.7920E3, 2.9640E3, 3.1440E3,
                                                        3.3280E3, 3.5190E3, 3.7160E3, 3.9200E3, 4.1310E3,
                                                        4.3470E3, 4.5700E3, 4.8000E3, 5.0360E3, 5.2800E3,
                                                        5.5310E3, 5.7890E3, 6.0520E3, 6.3220E3, 6.6020E3,
                                                        6.8910E3, 7.1800E3, 7.4780E3, 7.7880E3, 8.1040E3,
                                                        8.4180E3, 8.7480E3, 9.0890E3, 9.4240E3, 9.7790E3,
                                                        10.142E3, 10.514E3, 10.892E3, 11.283E3, 11.684E3,
                                                        12.094E3, 12.509E3, 12.939E3, 13.379E3, 13.828E3,
                                                        14.288E3, 14.762E3, 15.244E3, 15.740E3, 16.248E3,
                                                        16.768E3, 17.301E3, 17.845E3, 18.405E3, 18.977E3,
                                                        19.559E3, 20.163E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3]
#//------------------------------------------------------------------------------
#/**
# * Characteristic energy of the Ma line.
# *
# * Energy in eV.
# */
g_energyMa_eV =    [0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.833E3, 0.883E3, 0.929E3, 0.978E3,
                                                        1.033E3, 1.081E3, 1.131E3, 1.185E3, 1.240E3,
                                                        1.293E3, 1.348E3, 1.406E3, 1.462E3, 1.521E3,
                                                        1.581E3, 1.645E3, 1.710E3, 1.775E3, 1.843E3,
                                                        1.910E3, 1.980E3, 2.051E3, 2.123E3, 2.196E3,
                                                        2.271E3, 2.346E3, 2.423E3, 2.996E3, 3.082E3,
                                                        3.171E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                                                        0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3]

def getXRayEnergy_eV(atomicNumber, line='Ka1'):
    if line.lower() == 'Ka1'.lower():
        return g_energyKa1_eV[atomicNumber-1]

    if line.lower() == 'Ka2'.lower():
        return g_energyKa2_eV[atomicNumber-1]

    if line.lower() == 'Kb1'.lower():
        return g_energyKb1_eV[atomicNumber-1]

    if line.lower() == 'Kb2'.lower():
        return g_energyKb2_eV[atomicNumber-1]

    if line.lower() == 'La'.lower():
        return g_energyLa_eV[atomicNumber-1]

    if line.lower() == 'Lb1'.lower():
        return g_energyLb1_eV[atomicNumber-1]

    if line.lower() == 'Lb2'.lower():
        return g_energyLb2_eV[atomicNumber-1]

    if line.lower() == 'Lg'.lower():
        return g_energyLg_eV[atomicNumber-1]

    if line.lower() == 'Ma'.lower():
        return g_energyMa_eV[atomicNumber-1]

#/**
# * Ionization energy of K shell of element Z.
# *
# * in eV
# * From Eck(int Z).
# */
g_ionizationEnergyK_eV =    [0.01400E3, 0.02500E3, 0.05500E3, 0.11600E3, 0.19200E3,
                             0.28300E3, 0.33900E3, 0.53100E3, 0.68700E3, 0.87400E3,
                             1.08000E3, 1.30300E3, 1.55900E3, 1.83800E3, 2.14200E3,
                             2.47000E3, 2.81900E3, 3.20300E3, 3.60700E3, 4.03800E3,
                             4.49600E3, 4.96400E3, 5.46300E3, 5.98800E3, 6.53700E3,
                             7.11100E3, 7.70900E3, 8.33100E3, 8.98000E3, 9.66000E3,
                             10.3680E3, 11.1030E3, 11.8630E3, 12.6520E3, 13.4750E3,
                             14.3230E3, 15.2010E3, 16.1060E3, 17.0370E3, 17.9980E3,
                             18.9870E3, 20.0220E3, 21.0540E3, 22.1180E3, 23.2240E3,
                             24.3470E3, 25.5170E3, 26.7120E3, 27.9280E3, 29.1900E3,
                             30.4860E3, 31.8090E3, 33.1640E3, 34.5790E3, 35.9590E3,
                             37.4100E3, 38.9310E3, 40.4490E3, 41.9980E3, 43.5710E3,
                             45.2070E3, 46.8460E3, 48.5150E3, 50.2290E3, 51.9980E3,
                             53.7890E3, 55.6150E3, 57.4830E3, 59.3350E3, 61.3030E3,
                             63.3040E3, 65.3130E3, 67.4000E3, 69.5080E3, 71.6620E3,
                             73.8600E3, 76.0970E3, 78.3790E3, 80.7130E3, 83.1060E3,
                             85.5170E3, 88.0010E3, 90.5210E3, 93.1120E3, 95.7400E3,
                             98.4180E3, 101.147E3, 103.927E3, 106.759E3, 109.630E3,
                             112.581E3, 115.591E3, 118.619E3, 121.720E3, 124.876E3,
                             128.088E3]

#/**
# * Ionization energy of L3 shell of element Z in eV.
# *
# * From Ecl3(int Z).
# */
g_ionizationEnergyL3_eV = [0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3,
                                                        0.0000E3, 0.0000E3, 0.0000E3, 0.0000E3, 0.0220E3,
                                                        0.0340E3, 0.0490E3, 0.0720E3, 0.0980E3, 0.1280E3,
                                                        0.1630E3, 0.2020E3, 0.2450E3, 0.2940E3, 0.3490E3,
                                                        0.4060E3, 0.4540E3, 0.5120E3, 0.5740E3, 0.6390E3,
                                                        0.7080E3, 0.7790E3, 0.8530E3, 0.9330E3, 1.0220E3,
                                                        1.1170E3, 1.2170E3, 1.3230E3, 1.4340E3, 1.5520E3,
                                                        1.6750E3, 1.8060E3, 1.9410E3, 2.0790E3, 2.2200E3,
                                                        2.3740E3, 2.5230E3, 2.6770E3, 2.8370E3, 3.0020E3,
                                                        3.1720E3, 3.3520E3, 3.5380E3, 3.7290E3, 3.9280E3,
                                                        4.1320E3, 4.3410E3, 4.5590E3, 4.7820E3, 5.0110E3,
                                                        5.2470E3, 5.4890E3, 5.7290E3, 5.9680E3, 6.2150E3,
                                                        6.4660E3, 6.7210E3, 6.9830E3, 7.2520E3, 7.5190E3,
                                                        7.8500E3, 8.0740E3, 8.3640E3, 8.6520E3, 8.9430E3,
                                                        9.2410E3, 9.5560E3, 9.8760E3, 10.198E3, 10.531E3,
                                                        10.869E3, 11.211E3, 11.559E3, 11.919E3, 12.285E3,
                                                        12.657E3, 13.044E3, 13.424E3, 13.817E3, 14.215E3,
                                                        14.618E3, 15.028E3, 15.442E3, 15.865E3, 16.296E3,
                                                        16.731E3, 17.163E3, 17.614E3, 18.066E3, 18.525E3,
                                                        18.990E3]

#/**
# * Ionization energy of M5 shell of element Z in eV.
# *
# * From Ecm5(int Z).
# */
g_ionizationEnergyM5_eV = [0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                           0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                           0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                           0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                           0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                           0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                           0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                           0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                           0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                           0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                           0.000E3, 0.000E3, 0.000E3, 0.000E3, 0.000E3,
                           0.000E3, 0.832E3, 0.883E3, 0.931E3, 0.978E3,
                           1.027E3, 1.080E3, 1.130E3, 1.185E3, 1.241E3,
                           1.295E3, 1.351E3, 1.409E3, 1.467E3, 1.528E3,
                           1.588E3, 1.661E3, 1.743E3, 1.814E3, 1.890E3,
                           1.967E3, 2.048E3, 2.133E3, 2.220E3, 2.313E3,
                           2.406E3, 2.502E3, 2.603E3, 0.000E3, 0.000E3,
                           0.000E3, 0.000E3, 0.000E3, 0.000E3, 3.325E3,
                           3.442E3, 3.545E3, 0.000E3, 0.000E3, 0.000E3,
                           0.000E3]

def getIonizationEnergy_eV(atomicNumber, subshell='K'):
    if subshell[0].lower() == 'K'.lower():
        return g_ionizationEnergyK_eV[atomicNumber-1]

    if subshell[0].lower() == 'L'.lower():
        return g_ionizationEnergyL3_eV[atomicNumber-1]

    if subshell[0].lower() == 'M'.lower():
        return g_ionizationEnergyM5_eV[atomicNumber-1]

    return 0.0

def run():
    print(getIonizationEnergy_eV(47, 'K'))

if __name__ == '__main__': #pragma: no cover
    run()
